#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "LidarPerception_PubDataWrapper.h"
#include "LidarPerception_SubDataWrapper.h"
#include "lidar_perception/executable.h"

#include "LidarPerception_GeneralWrapper.h"


GeneralWrapper::GeneralWrapper(ara::log::Logger& mainLog) :
_LiDARPerception2Fusion_Provide("lidar_perception/lidar_perception/LiDARPerception2FusionPPort" ,mainLog),
_LiDAR2LiDARPerception_Required("lidar_perception/lidar_perception/LiDARInno2LiDARPerceptionRPort", mainLog),
_HesaiRight_Required("lidar_perception/lidar_perception/LiDARHesaiRight2LiDARPerceptionRPort", mainLog),
_HesaiLeft_Required("lidar_perception/lidar_perception/LiDARHesaiLeft2LiDARPerceptionRPort", mainLog),
_SLAM2LiDARPerceptionOdom_Required("lidar_perception/lidar_perception/Slam2LiDARPerceptionOdomRPort", mainLog),
_CAN2LiDARPerception_Required("lidar_perception/lidar_perception/CAN2LiDARPerceptionRPort", mainLog),
_VED2LiDARPerception_Required("lidar_perception/lidar_perception/VED2LiDARPerceptionRPort", mainLog)
{
	//Provides
	_LiDARPerception2Fusion_Provide.Init();

	//Requireds
	_LiDAR2LiDARPerception_Required.Init();
	_SLAM2LiDARPerceptionOdom_Required.Init();
	_CAN2LiDARPerception_Required.Init();
	_VED2LiDARPerception_Required.Init();

}

GeneralWrapper::~GeneralWrapper() {
	_LiDAR2LiDARPerception_Required.Destroy();
	_SLAM2LiDARPerceptionOdom_Required.Destroy();
	_CAN2LiDARPerception_Required.Destroy();
	_VED2LiDARPerception_Required.Destroy();
}
